Build instructions for the Clownfish compiler
=============================================

Building under UNIX and derivatives or Cygwin
---------------------------------------------

    $ ./configure
    $ make
    $ make test

Building under Windows
----------------------

You need MSVC or gcc as C compiler and nmake or mingw32-make as make utility.

When using cmd.exe configure with:

    $ configure.bat

When using the MSYS shell configure with:

    $ ./configure

When building with nmake run:

    $ nmake
    $ nmake test

When building with mingw32-make run:

    $ mingw32-make
    $ mingw32-make test

Configuration
-------------

    ./configure [ options ] [ -- cflags ]

Options include

    --enable-coverage
        Enable code coverage. Create HTML pages with coverage data using
        lcov by running "make coverage".

    --with-system-cmark
        The Clownfish compiler is built with a bundled version of libcmark
        by default. Use this option if you want to link against the system
        libcmark.
